"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$params = exports.$path = void 0;
function includesParams(route) {
    return route.indexOf('/:') > -1 || route.indexOf('/*') > -1;
}
function $path(route, ...paramsOrQuery) {
    var _a;
    let path = route;
    let query = paramsOrQuery[0];
    if (includesParams(route)) {
        const params = (_a = paramsOrQuery[0]) !== null && _a !== void 0 ? _a : {};
        query = paramsOrQuery[1];
        path = route.split('/').map(fragment => {
            if (fragment.indexOf(':') > -1) {
                let paramName = fragment.slice(1);
                if (paramName.indexOf('?') > -1) {
                    paramName = paramName.slice(0, -1);
                }
                if (paramName in params) {
                    return params[paramName];
                }
                return null;
            }
            if (fragment == "*") {
                if ("*" in params) {
                    return params["*"];
                }
                return null;
            }
            return fragment;
        }).filter(f => f !== null).join('/');
    }
    if (!query) {
        return path;
    }
    const searchParams = new URLSearchParams(query);
    return path + '?' + searchParams.toString();
}
exports.$path = $path;
function $params(_route, params) {
    return params;
}
exports.$params = $params;
